      SUBROUTINE AGT0R(A,B,V,ALFR,ALFI,BETA,N,IERR)
      DIMENSION A(N,N),B(N,N),V(N,N),ALFR(N),ALFI(N),BETA(N)
      INTEGER N,IERR,I,J,M,L,L1,K,MR,MI,IRET
      REAL A,B,V,ALFR,ALFI,BETA,E,CZ,TI,V1,A21,B11,SQR,SZR,
     1A11R,A21R,EPSA,AN,EI,TR,V2,A22,B12,SSI,A12I,A22I,EPSB,
     1C,R,BN,ER,U1,A11,BDI,B22,SSR,A12R,A22R,D,T,CQ,U2,A12,
     1BDR,SQI,SZI,A11I,A21I,DI,SLI,TLK,TKLR,TLLR,DR,SLR,TLL,
     1ALMI,TKKI,TLKI,S,SK,SKI,TKK,ALMR,TKKR,TLKR,SL,SKR,TKL,
     1ALFM,TKLI,TLLI,XR,XI,YR,YI,ZR,ZI,H,BETM,ZERO,ONE,F,
     1HALF,ANORM,BNORM,ANI,BNI,EPS,SYS051
      LOGICAL FLIP
      DATA  ZERO/0./,ONE/1./,HALF/0.5/,SYS051/1.192093E-07/
      IERR=0
      EPS=SYS051
      CALL AFT0R(A,B,V,N,0,IERR)
      ANORM=ZERO
      BNORM=ZERO
      DO 2 I=1,N
      ANI=ZERO
      IF(I.NE.1) ANI=ABS(A(I,I-1))
      BNI=ZERO
      DO 1 J=1,N
      ANI=ANI+ABS(A(I,J))
      BNI=BNI+ABS(B(I,J))
    1 CONTINUE
      IF(ANI.GT.ANORM) ANORM=ANI
      IF(BNI.GT.BNORM) BNORM=BNI
    2 CONTINUE
      IF(ANORM.EQ.ZERO) ANORM=EPS
      IF(BNORM.EQ.ZERO) BNORM=EPS
      EPSA=EPS*ANORM
      EPSB=EPS*BNORM
      M=N
    3 CONTINUE
      IF(M.EQ.1) GO TO 4
      IF(A(M,M-1).NE.ZERO) GO TO 5
    4 ALFR(M)=A(M,M)
      IF(B(M,M).LT.ZERO) ALFR(M)=-ALFR(M)
      BETA(M)=ABS(B(M,M))
      ALFI(M)=ZERO
      M=M-1
      GO TO 16
    5 L=M-1
      IF(ABS(B(L,L)).GT.EPSB) GO TO 6
      B(L,L)=ZERO
      CALL AM12R(A(L,L),A(M,L),U1,U2,V1,V2)
      GO TO 12
    6 IF(ABS(B(M,M)).GT.EPSB) GO TO 7
      B(M,M)=ZERO
      CALL AM12R(A(M,M),A(M,L),U1,U2,V1,V2)
      BN=ZERO
      GO TO 8
    7 AN=ABS(A(L,L))+ABS(A(L,M))+ABS(A(M,L))+ABS(A(M,M))
      BN=ABS(B(L,L))+ABS(B(L,M))+ABS(B(M,M))
      F=ONE/AN
      A11=A(L,L)*F
      A12=A(L,M)*F
      A21=A(M,L)*F
      A22=A(M,M)*F
      F=ONE/BN
      B11=B(L,L)*F
      B12=B(L,M)*F
      B22=B(M,M)*F
      E=A11/B11
      C=((A22-E*B22)/B22-(A21*B12)/(B11*B22))*HALF
      D=C*C+(A21*(A12-E*B12))/(B11*B22)
      IF(D.LT.ZERO) GO TO 15
      IF(C.GE.ZERO) E=E+(C+SQRT(D))
      IF(C.LT.ZERO) E=E+(C-SQRT(D))
      A11=A11-E*B11
      A12=A12-E*B12
      A22=A22-E*B22
      FLIP=(ABS(A11)+ABS(A12)).GE.(ABS(A21)+ABS(A22))
      IF(FLIP) CALL AM12R(A12,A11,U1,U2,V1,V2)
      IF(.NOT.FLIP) CALL AM12R(A22,A21,U1,U2,V1,V2)
    8 IF(U1.NE.ONE) GO TO 11
      DO 9 I=1,M
      T=A(I,M)+U2*A(I,L)
      A(I,M)=A(I,M)+V1*T
      A(I,L)=A(I,L)+V2*T
      T=B(I,M)+U2*B(I,L)
      B(I,M)=B(I,M)+V1*T
      B(I,L)=B(I,L)+V2*T
    9 CONTINUE
      DO 10 I=1,N
      T=V(I,M)+U2*V(I,L)
      V(I,M)=V(I,M)+V1*T
      V(I,L)=V(I,L)+V2*T
   10 CONTINUE
   11 IF(BN.EQ.ZERO) GO TO 14
      FLIP=AN.GE.ABS(E)*BN
      IF(FLIP) CALL AM12R(B(L,L),B(M,L),U1,U2,V1,V2)
   12 IF(U1.NE.ONE) GO TO 14
      IF(.NOT.FLIP) CALL AM12R(A(L,L),A(M,L),U1,U2,V1,V2)
      DO 13 J=L,N
      T=A(L,J)+U2*A(M,J)
      A(L,J)=A(L,J)+V1*T
      A(M,J)=A(M,J)+V2*T
      T=B(L,J)+U2*B(M,J)
      B(L,J)=B(L,J)+V1*T
      B(M,J)=B(M,J)+V2*T
   13 CONTINUE
   14 A(M,L)=ZERO
      B(M,L)=ZERO
      ALFR(L)=A(L,L)
      ALFR(M)=A(M,M)
      IF(B(L,L).LT.ZERO)ALFR(L)=-ALFR(L)
      IF(B(M,M).LT.ZERO)ALFR(M)=-ALFR(M)
      BETA(L)=ABS(B(L,L))
      BETA(M)=ABS(B(M,M))
      ALFI(M)=ZERO
      ALFI(L)=ZERO
      M=M-2
      GO TO 16
   15 ER=E+C
      EI=SQRT(-D)
      A11R=A11-ER*B11
      A11I=EI*B11
      A12R=A12-ER*B12
      A12I=EI*B12
      A21R=A21
      A21I=ZERO
      A22R=A22-ER*B22
      A22I=EI*B22
      FLIP=(ABS(A11R)+ABS(A11I)+ABS(A12R)+ABS(A12I))
     1.GE.(ABS(A21R)+ABS(A22R)+ABS(A22I))
      IF(FLIP) CALL AM12C(A12R,A12I,-A11R,-A11I,CZ,SZR,SZI)
      IF(.NOT.FLIP) CALL AM12C(A22R,A22I,-A21R,-A21I,CZ,SZR,SZI)
      FLIP=AN.GE.(ABS(ER)+ABS(EI))*BN
      IF(FLIP) CALL AM12C(CZ*B11+SZR*B12,SZI*B12,SZR*B22,
     1SZI*B22,CQ,SQR,SQI)
      IF(.NOT.FLIP) CALL AM12C(CZ*A11+SZR*A12,SZI*A12,CZ*
     1A21+SZR*A22, SZI*A22,CQ,SQR,SQI)
      SSR=SQR*SZR+SQI*SZI
      SSI=SQR*SZI-SQI*SZR
      TR=CQ*CZ*A11+CQ*SZR*A12+SQR*CZ*A21+SSR*A22
      TI=CQ*SZI*A12-SQI*CZ*A21+SSI*A22
      BDR=CQ*CZ*B11+CQ*SZR*B12+SSR*B22
      BDI=CQ*SZI*B12+SSI*B22
      R=SQRT(BDR*BDR+BDI*BDI)
      BETA(L)=BN*R
      ALFR(L)=AN*(TR*BDR+TI*BDI)/R
      ALFI(L)=AN*(TR*BDI-TI*BDR)/R
      TR=SSR*A11-SQR*CZ*A12-CQ*SZR*A21+CQ*CZ*A22
      TI=-SSI*A11-SQI*CZ*A12+CQ*SZI*A21
      BDR=SSR*B11-SQR*CZ*B12+CQ*CZ*B22
      BDI=-SSI*B11-SQI*CZ*B12
      R=SQRT(BDR*BDR+BDI*BDI)
      BETA(M)=BN*R
      ALFR(M)=AN*(TR*BDR+TI*BDI)/R
      ALFI(M)=AN*(TR*BDI-TI*BDR)/R
      M=M-2
   16 IF(M.GT.0) GO TO 3
      M=N
   17 CONTINUE
      IF(ALFI(M).NE.ZERO) GO TO 24
      ALFM=ALFR(M)
      BETM=BETA(M)
      B(M,M)=ONE
      L=M-1
      IF(L.EQ.0) GO TO 23
   18 CONTINUE
      L1=L+1
      SL=ZERO
      DO 19 J=L1,M
      SL=SL+(BETM*A(L,J)-ALFM*B(L,J))*B(J,M)
   19 CONTINUE
      IF(L.EQ.1) GO TO 20
      IF(BETM*A(L,L-1).NE.ZERO) GO TO 21
   20 D=BETM*A(L,L)-ALFM*B(L,L)
      IF(D.EQ.ZERO) D=(EPSA+EPSB)*HALF
      B(L,M)=-SL/D
      L=L-1
      GO TO 23
   21 K=L-1
      SK=ZERO
      DO 22 J=L1,M
      SK=SK+(BETM*A(K,J)-ALFM*B(K,J))*B(J,M)
   22 CONTINUE
      TKK=BETM*A(K,K)-ALFM*B(K,K)
      TKL=BETM*A(K,L)-ALFM*B(K,L)
      TLK=BETM*A(L,K)
      TLL=BETM*A(L,L)-ALFM*B(L,L)
      D=TKK*TLL-TKL*TLK
      IF(D.EQ.ZERO) D=(EPSA+EPSB)*HALF
      B(L,M)=(TLK*SK-TKK*SL)/D
      FLIP=ABS(TKK).GE.ABS(TLK)
      IF(FLIP) B(K,M)=-(SK+TKL*B(L,M))/TKK
      IF(.NOT.FLIP) B(K,M)=-(SL+TLL*B(L,M))/TLK
      L=L-2
   23 IF(L.GT.0) GO TO 18
      M=M-1
      GO TO 35
   24 ALMR=ALFR(M-1)
      ALMI=ALFI(M-1)
      BETM=BETA(M-1)
      MR=M-1
      MI=M
      B(M-1,MR)=ALMI*B(M,M)/(BETM*A(M,M-1))
      B(M-1,MI)=(BETM*A(M,M)-ALMR*B(M,M))/(BETM*A(M,M-1))
      B(M,MR)=ZERO
      B(M,MI)=-ONE
      L=M-2
      IF(L.EQ.0) GO TO 34
   25 CONTINUE
      L1=L+1
      SLR=ZERO
      SLI=ZERO
      DO 26 J=L1,M
      TR=BETM*A(L,J)-ALMR*B(L,J)
      TI=-ALMI*B(L,J)
      SLR=SLR+TR*B(J,MR)-TI*B(J,MI)
      SLI=SLI+TR*B(J,MI)+TI*B(J,MR)
   26 CONTINUE
      IF(L.EQ.1) GO TO 27
      IF(BETM*A(L,L-1).NE.ZERO) GO TO 29
   27 DR=BETM*A(L,L)-ALMR*B(L,L)
      DI=-ALMI*B(L,L)
      IRET=1
      XR=-SLR
      XI=-SLI
      YR=DR
      YI=DI
      GO TO 47
   28 B(L,MR)=ZR
      B(L,MI)=ZI
      L=L-1
      GO TO 34
   29 K=L-1
      SKR=ZERO
      SKI=ZERO
      DO 30 J=L1,M
      TR=BETM*A(K,J)-ALMR*B(K,J)
      TI=-ALMI*B(K,J)
      SKR=SKR+TR*B(J,MR)-TI*B(J,MI)
      SKI=SKI+TR*B(J,MI)+TI*B(J,MR)
   30 CONTINUE
      TKKR=BETM*A(K,K)-ALMR*B(K,K)
      TKKI=-ALMI*B(K,K)
      TKLR=BETM*A(K,L)-ALMR*B(K,L)
      TKLI=-ALMI*B(K,L)
      TLKR=BETM*A(L,K)
      TLKI=ZERO
      TLLR=BETM*A(L,L)-ALMR*B(L,L)
      TLLI=-ALMI*B(L,L)
      DR=TKKR*TLLR-TKKI*TLLI-TKLR*TLKR
      DI=TKKR*TLLI+TKKI*TLLR-TKLI*TLKR
      IF(DR.EQ.ZERO.AND.DI.EQ.ZERO) DR=(EPSA+EPSB)*HALF
      IRET=2
      XR=TLKR*SKR-TKKR*SLR+TKKI*SLI
      XI=TLKR*SKI-TKKR*SLI-TKKI*SLR
      YR=DR
      YI=DI
      GO TO 47
   31 B(L,MR)=ZR
      B(L,MI)=ZI
      FLIP=(ABS(TKKR)+ABS(TKKI)).GE.ABS(TLKR)
      IRET=3
      IF(FLIP) GO TO 32
      XR=-SLR-TLLR*B(L,MR)+TLLI*B(L,MI)
      XI=-SLI-TLLR*B(L,MI)-TLLI*B(L,MR)
      YR=TLKR
      YI=TLKI
      GO TO 47
   32 XR=-SKR-TKLR*B(L,MR)+TKLI*B(L,MI)
      XI=-SKI-TKLR*B(L,MI)-TKLI*B(L,MR)
      YR=TKKR
      YI=TKKI
      GO TO 47
   33 B(K,MR)=ZR
      B(K,MI)=ZI
      L=L-2
   34 IF(L.GT.0) GO TO 25
      M=M-2
   35 IF(M.GT.0) GO TO 17
      M=N
   36 CONTINUE
      DO 38 I=1,N
      S=ZERO
      DO 37 J=1,M
      S=S+V(I,J)*B(J,M)
   37 CONTINUE
      V(I,M)=S
   38 CONTINUE
      M=M-1
      IF(M.GT.0) GO TO 36
      M=N
   39 CONTINUE
      S=ZERO
      IF(ALFI(M).NE.ZERO) GO TO 42
      DO 40 I=1,N
      R=ABS(V(I,M))
      IF(R.LT.S) GO TO 40
      S=R
      D=V(I,M)
   40 CONTINUE
      DO 41 I=1,N
      V(I,M)=V(I,M)/D
   41 CONTINUE
      M=M-1
      GO TO 46
   42 DO 43 I=1,N
      R=ABS(V(I,M-1))+ABS(V(I,M))
      R=R*SQRT((V(I,M-1)/R)**2+(V(I,M)/R)**2)
      IF(R.LT.S) GO TO 43
      S=R
      DR=V(I,M-1)
      DI=V(I,M)
   43 CONTINUE
      IRET=4
      I=0
   44 I=I+1
      XR=V(I,M-1)
      XI=V(I,M)
      YR=DR
      YI=DI
      GO TO 47
   45 V(I,M-1)=ZR
      V(I,M)=ZI
      IF(I.LT.N) GO TO 44
      M=M-2
   46 IF(M.GT.0) GO TO 39
      GO TO 50
   47 IF(ABS(YR).LT.ABS(YI)) GO TO 48
      H=YI/YR
      F=YR+H*YI
      ZR=(XR+H*XI)/F
      ZI=(XI-H*XR)/F
      GO TO 49
   48 H=YR/YI
      F=YI+H*YR
      ZR=(H*XR+XI)/F
      ZI=(H*XI-XR)/F
   49 GO TO (28,31,33,45),IRET
   50 IF(IERR.NE.0) CALL UTAG10(IERR,41)
      RETURN
      END
